from turtle import *
from time import *

"""
The program (modules and variables) that searches out the nodal paths is imported.
This allows us to access the list of all possible paths
"""
from Program_TownTourSearch import *

# Trace out a path for a "hamiltonian" one-stop walk, passed as a list
def walkTheWalk(hamList) :
    nodeTurtle.pendown()
    for tempNode in hamList :
        print("vertex", tempNode["vertex"], tempNode["coords"])
        nodeTurtle.setpos(tempNode["coords"])
        nodeTurtle.stamp()

# Create a turtle to draw the graph of tourist sites
def drawSitesGraph() :
    dotTurtle = Turtle()
    dotTurtle.shape("blank")
    dotTurtle.color("goldenrod1")
    dotTurtle.hideturtle()
    dotTurtle.penup()
    dotTurtle.pensize(10)

    nodalGraphCoords = [hotelNode, churchNode, gpoNode, deansgrangeNode, artgalleryNode]

    for tempNode in nodalGraphCoords :
        dotTurtle.setpos(tempNode["coords"]) #head to first node location
        dotTurtle.penup()
        dotTurtle.dot(20,"blue")
        dotTurtle.write("    " + tempNode["vertex"], "center",font=("Arial",16,"bold"))
        dotTurtle.setpos(tempNode["coords"]) #reset to first node location
        #dotTurtle.pendown()
        for connectedNode in tempNode["nodeList"] :
            dotTurtle.pendown()
            dotTurtle.setpos(connectedNode["coords"])
            dotTurtle.penup()
            dotTurtle.dot(20,"blue")
            
            dotTurtle.write("    " + connectedNode["vertex"], "center", font=("Arial",16,"bold"))
            
            dotTurtle.penup()   #head back to original tempNode
            dotTurtle.setpos(tempNode["coords"])  #head to first node location
            
    dotTurtle.showturtle()


# set up the turtle canvas
mainscreen = Screen()
mainscreen.mode("standard")
mainscreen.setup(850, 850)
#mainscreen.bgcolor("red")
mainscreen.bgpic("dubzoo.png")

drawSitesGraph()    # draw all the sites with Dublin Zoo in the bground
beginNodalTrip()    # figure out all the paths from hotel to hotel

for turtlePath in listOfPaths :
    if len(turtlePath) == 9 :
        strTurtlePath = "a tour of DUBLIN that takes in all the sites ONCE"
        banville = Turtle()
        banville.penup()
        banville.shape("blank")
        banville.setpos(-320,-380)
        banville.color("red")

        banville.write(strTurtlePath,font=("Arial",16,"bold"))

        nodeTurtle = Turtle()
        nodeTurtle.penup()
        nodeTurtle.shape("turtle")
        nodeTurtle.color("green")
        nodeTurtle.pensize(10)
        nodeTurtle.speed(1)
        nodeTurtle.setpos(startNode["coords"])
        #nodeTurtle.setx(10)
    
        walkTheWalk(turtlePath)
        mainscreen.textinput("NEXT PATH " + strTurtlePath,"click to see next path")

        #sleep(3)
        nodeTurtle.clear()




