"""
Description of the Tour Guide Puzzle.
This is a very basic version of a general problem in computer science.
How to cross a network along the shortest path or along a path that visits every node once.
This problem has 8 nodes.
We start at the hotel and want to visit the 7 tourist sites.
The program will recursively go through the network and list all possible paths from hotel to hotel.

(Recursion is dealt with in the lesson slides.)
"""

import time

"""
A definition(function) for describing a node .. each attribute is described:
    vertex is the name of the tourist site ("hotel", "gpo", etc.)
    nodeList is the list of other nodes connected to this node

    coords will be used  for the graphical (Turtle) output (not used in this standalone version)
        
"""
def createNode (tourSite, nodeList, coords) :
    node = {"vertex": tourSite, "nodeList": nodeList, "coords": coords}
    return node

def Network_Traipse(node, pathlist) :
    pathlist = pathlist + [node]

    #the endgame is reached if we are at the start/end node, but not as we leave the hotel!
    if node == endNode and len(pathlist) > 1 :
        listOfPaths.append(pathlist)
        return

    for tempnode in node["nodeList"] :
        if tempnode not in pathlist or tempnode == startNode:
            #print("tempnode ", tempnode[vertex]) # debugging prints
            Network_Traipse(tempnode, pathlist)
    return




# Initialise the 8 tour sites (i.e. the nodal network) 
hotelNode = createNode("hotel",[], (0, 300))
museumNode = createNode("museum",[], (200, 300))
artgalleryNode = createNode("artgallery",[], (250, 0))
deansgrangeNode = createNode("deansgrange",[], (0, -300))
zooNode = createNode("zoo",[], (-300, 0))
churchNode = createNode("church",[], (0, 150))
tcdNode = createNode("tcd",  [], (150, 0))
gpoNode = createNode("gpo", [], (0, -150))

# set up the edges
hotelNode["nodeList"] = [zooNode, museumNode, churchNode]
museumNode["nodeList"] = [hotelNode, artgalleryNode]
artgalleryNode["nodeList"] = [museumNode, deansgrangeNode]
deansgrangeNode["nodeList"] = [zooNode, artgalleryNode]
zooNode["nodeList"] = [hotelNode, gpoNode, deansgrangeNode]
churchNode["nodeList"] = [tcdNode, gpoNode, hotelNode]
tcdNode["nodeList"] = [churchNode, gpoNode]
gpoNode["nodeList"] = [zooNode, tcdNode, churchNode]

print("assigning start and end nodes")
startNode = hotelNode
endNode = hotelNode

pathlist = [] #store paths as a list of integers, representing the nodes
listOfPaths = []  #an unfiltered list of paths from start - end



def beginNodalTrip() :
    startTime = time.clock()
    Network_Traipse(startNode, pathlist)
    endTime = time.clock()
    for possPaths in listOfPaths :
        if len(possPaths) == 9 :
            print("\nRecommended Itinerary")
            for tourSites in possPaths :
                print("->", tourSites["vertex"], end = "")
            print("\n\n------------------------------------")
    print ("time taken is ", format(endTime - startTime,'.2f'), "seconds")



if __name__ == "__main__" :
    beginNodalTrip()
    




